module user_sdio_cmd52_if(
//--------clock and reset---------
input           clk,  //sd clock
input           rstn, //system rstn
input           fun1_rst,  

input               sdio_cmd52_cs,
input               sdio_cmd52_r_w,
input               sdio_cmd52_fn_num,
input               sdio_cmd52_raw,//1:The Read after Write flag
input [16:0]        sdio_cmd52_addr,
input [7:0]         sdio_cmd52_wr_data,
output reg [7:0]        sdio_cmd52_rd_data,
output reg             sdio_cmd52_ack
);
wire CIS_Area;
reg CIS_Area_reg;
assign CIS_Area = sdio_cmd52_cs & ((sdio_cmd52_fn_num)?1'b0:((|sdio_cmd52_addr[16:12])&(~(&sdio_cmd52_addr[16:15]))));
always@(posedge clk or negedge rstn) begin
    if (!rstn) begin
        CIS_Area_reg <= 1'b0;
    end
    else if (sdio_cmd52_cs) begin
        CIS_Area_reg <= CIS_Area;
    end
end

wire config_Area;
reg config_Area_reg;
assign config_Area = sdio_cmd52_cs & (sdio_cmd52_fn_num)&((|sdio_cmd52_addr[16:4])?1'b0:1'b1);
always@(posedge clk or negedge rstn) begin
    if (!rstn) begin
        config_Area_reg <= 1'b0;
    end
    else if (sdio_cmd52_cs) begin
        config_Area_reg <= config_Area;
    end
end

reg sdio_cmd52_cs_d1;
reg sdio_cmd52_r_w_d1;
//reg sdio_cmd52_fn_num_d1;
//reg sdio_cmd52_raw_d1;
reg [6:0] sdio_cmd52_addr_reg;
reg sdio_cmd52_addr12_reg;

reg [7:0] sdio_cmd52_wr_data_reg;
//reg [7:0] sdio_cmd52_rd_data;
//reg sdio_cmd52_ack;

reg [7:0] user_cmd52_read_reg;
reg [7:0] user_cmd52_write_return_reg;

reg [7:0] func1_config0;
reg [7:0] func1_config1;
reg [7:0] func1_config2;
reg [7:0] func1_config3;

always@(posedge clk or negedge rstn) begin
    if (!rstn) begin
        sdio_cmd52_cs_d1 <= 1'b0;
        sdio_cmd52_r_w_d1 <= 1'b0;
//        sdio_cmd52_fn_num_d1 <= 1'b0;
//        sdio_cmd52_raw_d1 <= 1'b0;
		sdio_cmd52_ack <= 1'b0;
    end
    else if (fun1_rst) begin
        sdio_cmd52_cs_d1 <= 1'b0;
        sdio_cmd52_r_w_d1 <= 1'b0;
//        sdio_cmd52_fn_num_d1 <= 1'b0;
//        sdio_cmd52_raw_d1 <= 1'b0;
		sdio_cmd52_ack <= 1'b0;
    end
    else if (sdio_cmd52_ack) begin
        sdio_cmd52_cs_d1 <= 1'b0;
        sdio_cmd52_r_w_d1 <= 1'b0;
 //       sdio_cmd52_fn_num_d1 <= 1'b0;
//        sdio_cmd52_raw_d1 <= 1'b0;
		sdio_cmd52_ack <= 1'b0;
    end
    else begin
        sdio_cmd52_cs_d1 <= sdio_cmd52_cs;
        sdio_cmd52_r_w_d1 <= sdio_cmd52_cs&sdio_cmd52_r_w;
 //       sdio_cmd52_fn_num_d1 <= sdio_cmd52_fn_num;
//        sdio_cmd52_raw_d1 <= sdio_cmd52_raw;
		sdio_cmd52_ack <= sdio_cmd52_cs_d1;
    end
end


always@(posedge clk) begin
	if(sdio_cmd52_cs) begin
		sdio_cmd52_addr_reg<=sdio_cmd52_addr[6:0];
        sdio_cmd52_addr12_reg<=sdio_cmd52_addr[12];
		sdio_cmd52_wr_data_reg<=sdio_cmd52_wr_data;
	end
end

always@(posedge clk) begin
	if(sdio_cmd52_cs_d1) begin
	    if(sdio_cmd52_r_w_d1) begin
			sdio_cmd52_rd_data <= sdio_cmd52_wr_data_reg; 
		end
		else if (config_Area_reg) begin
                case(sdio_cmd52_addr_reg)
                    7'b0000000: sdio_cmd52_rd_data<=func1_config0;
                    7'b0000001: sdio_cmd52_rd_data<=func1_config1;
                    7'b0000010: sdio_cmd52_rd_data<=func1_config2;
                    7'b0000011: sdio_cmd52_rd_data<=func1_config3;
                    7'b0000100: sdio_cmd52_rd_data<=8'hff;  //bit 0- 1:has data, 0:no data
                    default: sdio_cmd52_rd_data<=8'hff;
                endcase
		end
		else if (CIS_Area_reg) begin
            if (~sdio_cmd52_addr12_reg) begin  /*Func 1 */
                case(sdio_cmd52_addr_reg)
                    7'b0000000: sdio_cmd52_rd_data<=8'h20;
                    7'b0000001: sdio_cmd52_rd_data<=8'h04;
                    7'b0000010: sdio_cmd52_rd_data<=8'hD0;
                    7'b0000011: sdio_cmd52_rd_data<=8'h02;
                    7'b0000100: sdio_cmd52_rd_data<=8'he8;
                    7'b0000101: sdio_cmd52_rd_data<=8'haa;

                    7'b0000110: sdio_cmd52_rd_data<=8'h21;
                    7'b0000111: sdio_cmd52_rd_data<=8'h02;
                    7'b0001000: sdio_cmd52_rd_data<=8'h0C;
                    7'b0001001: sdio_cmd52_rd_data<=8'h00;

                    7'b0001010: sdio_cmd52_rd_data<=8'h22;
                    7'b0001011: sdio_cmd52_rd_data<=8'h2A;
                    7'b0001100: sdio_cmd52_rd_data<=8'h01;
                    7'b0001101: sdio_cmd52_rd_data<=8'h00;  //FUNC_INFO
                    7'b0001110: sdio_cmd52_rd_data<=8'h00;  //STD_IO_REV
                    7'b0001111: sdio_cmd52_rd_data<=8'h00;  //CARD_PSN
                    7'b0010000: sdio_cmd52_rd_data<=8'h00;
                    7'b0010001: sdio_cmd52_rd_data<=8'h00;
                    7'b0010010: sdio_cmd52_rd_data<=8'h00;
                    7'b0010011: sdio_cmd52_rd_data<=8'h00;  //CSA_SIZE
                    7'b0010100: sdio_cmd52_rd_data<=8'h00;
                    7'b0010101: sdio_cmd52_rd_data<=8'h00;
                    7'b0010110: sdio_cmd52_rd_data<=8'h00;
                    7'b0010111: sdio_cmd52_rd_data<=8'h00;  //CSA_PROPERTY
                    7'b0011000: sdio_cmd52_rd_data<=8'h00;  //MAX_BLK_SIZE
                    7'b0011001: sdio_cmd52_rd_data<=8'h04;
                    7'b0011010: sdio_cmd52_rd_data<=8'h00;  //OCR
                    7'b0011011: sdio_cmd52_rd_data<=8'hFF;
                    7'b0011100: sdio_cmd52_rd_data<=8'hFF;
                    7'b0011101: sdio_cmd52_rd_data<=8'h80; 
                    7'b0011110: sdio_cmd52_rd_data<=8'h00;  //OP_MIN_PWR
                    7'b0011111: sdio_cmd52_rd_data<=8'h00;  //OP_AVG_PWR
                    7'b0100000: sdio_cmd52_rd_data<=8'h00;  //OP_MAX_PWR
                    7'b0100001: sdio_cmd52_rd_data<=8'h00;  //SB_MIN_PWR
                    7'b0100010: sdio_cmd52_rd_data<=8'h00;  //SB_AVG_PWR
                    7'b0100011: sdio_cmd52_rd_data<=8'h00;  //SB_MAX_PWR
                    7'b0100100: sdio_cmd52_rd_data<=8'h00;  //MIN_BW
                    7'b0100101: sdio_cmd52_rd_data<=8'h00;
                    7'b0100110: sdio_cmd52_rd_data<=8'h00;  //OPT_BW
                    7'b0100111: sdio_cmd52_rd_data<=8'h00;
                    7'b0101000: sdio_cmd52_rd_data<=8'h00;  //ENABLE_TIMEOUT_VAL
                    7'b0101001: sdio_cmd52_rd_data<=8'h00;
                    7'b0101010: sdio_cmd52_rd_data<=8'h00;  //SP_AVG_PWR_3.3V
                    7'b0101011: sdio_cmd52_rd_data<=8'h00;  
                    7'b0101100: sdio_cmd52_rd_data<=8'h00;  //SP_MAX_PWR_3.3V
                    7'b0101101: sdio_cmd52_rd_data<=8'h00; 
                    7'b0101110: sdio_cmd52_rd_data<=8'h00;  //HP_AVG_PWR_3.3V
                    7'b0101111: sdio_cmd52_rd_data<=8'h00;
                    7'b0110000: sdio_cmd52_rd_data<=8'h00;  //HP_MAX_PWR_3.3V
                    7'b0110001: sdio_cmd52_rd_data<=8'h00;
                    7'b0110010: sdio_cmd52_rd_data<=8'h00;  //LP_AVG_PWR_3.3V
                    7'b0110011: sdio_cmd52_rd_data<=8'h00;
                    7'b0110100: sdio_cmd52_rd_data<=8'h00;  //LP_MAX_PWR_3.3V
                    7'b0110101: sdio_cmd52_rd_data<=8'h00;


                    7'b0110110: sdio_cmd52_rd_data<=8'hFF;
                    7'b0110111: sdio_cmd52_rd_data<=8'h00;

                    default: sdio_cmd52_rd_data<=8'h00;
                endcase
            end
            else begin                         /*Func 0 */
               case(sdio_cmd52_addr_reg)
                    7'b0000000: sdio_cmd52_rd_data<=8'h20;
                    7'b0000001: sdio_cmd52_rd_data<=8'h04;
                    7'b0000010: sdio_cmd52_rd_data<=8'hD0;
                    7'b0000011: sdio_cmd52_rd_data<=8'h02;
                    7'b0000100: sdio_cmd52_rd_data<=8'he8;
                    7'b0000101: sdio_cmd52_rd_data<=8'haa;

                    7'b0000110: sdio_cmd52_rd_data<=8'h21;
                    7'b0000111: sdio_cmd52_rd_data<=8'h02;
                    7'b0001000: sdio_cmd52_rd_data<=8'h0C;
                    7'b0001001: sdio_cmd52_rd_data<=8'h00;

                    7'b0001010: sdio_cmd52_rd_data<=8'h22;
                    7'b0001011: sdio_cmd52_rd_data<=8'h04;
                    7'b0001100: sdio_cmd52_rd_data<=8'h00;
                    7'b0001101: sdio_cmd52_rd_data<=8'h20;
                    7'b0001110: sdio_cmd52_rd_data<=8'h00;
                    7'b0001111: sdio_cmd52_rd_data<=8'h23;   //3E;//8'h0B;  //change to 8'h2B for SDR104, 8'h1b for 130MHz, 8'h23 for 150MHz

                    7'b0010000: sdio_cmd52_rd_data<=8'hFF;
                    7'b0010001: sdio_cmd52_rd_data<=8'h00;
                    default: sdio_cmd52_rd_data<=8'h00;
                endcase
            end
		end
		else begin
			sdio_cmd52_rd_data<=8'hff;
		end
	end
end

always@(posedge clk  or negedge rstn) begin
    if (!rstn) begin
        func1_config0 <= 'b0;
        func1_config1 <= 'b0;
        func1_config2 <= 'b0;
        func1_config3 <= 'b0;
    end
    else if (sdio_cmd52_cs_d1 & sdio_cmd52_r_w_d1) begin
		case(sdio_cmd52_addr_reg)
			4'b0000: func1_config0 <= sdio_cmd52_wr_data_reg;
			4'b0001: func1_config1 <= sdio_cmd52_wr_data_reg;
			4'b0010: func1_config2 <= sdio_cmd52_wr_data_reg;
			4'b0011: func1_config3 <= sdio_cmd52_wr_data_reg;
		endcase
	end
end

endmodule


