
module user_tuning_pattern(
//--------clock and reset---------
input               clk,  //sd clock
input               rstn, //system rstn
input               cmd52_rst,   //cmd52 rst

input               sdio_tuning_start,
//output [3:0]        sdio_tuning_data,
output [7:0]        sdio_tuning_data, //modify
output              sdio_tuning_end
);

localparam tuning_pattern = 576'hff0fff00_ffccc3cc_c33cccff_fefffeef_ffdfffdd_fffbfffb_bfff7fff_77f7bdef_fff0fff0_0ffccc3c_cc33cccf_ffefffee_fffdfffd_dfffbfff_bbfff7ff_f77f7bde_f9503a4b_c5488fbc;

reg [7:0] cnt;
reg tuning_flag;

always@(posedge clk or negedge rstn) begin
    if (!rstn) begin
        tuning_flag <= 1'b0;
    end
    else if (cmd52_rst) begin
        tuning_flag <= 1'b0;
    end
    else if (sdio_tuning_start) begin
        tuning_flag <= 1'b1;
    end
    else if (cnt == 8'd71) begin
        tuning_flag <= 1'b0;
    end
end

always@(posedge clk or negedge rstn) begin
    if (!rstn) begin
        cnt <= 'b0;
    end
    else if (cmd52_rst) begin
        cnt <= 'b0;
    end
    else if (tuning_flag) begin
        cnt <= cnt + 1'b1;
    end
    else begin
        cnt <= 'b0;
    end
end

assign sdio_tuning_end = tuning_flag && cnt == 8'd71;
//assign sdio_tuning_data = (tuning_flag) ? tuning_pattern[(572-4*cnt)+:4] : 4'b0;
assign sdio_tuning_data = (tuning_flag) ? tuning_pattern[(568-8*cnt)+:8] : 8'b0;

endmodule
